--
-- vahaTrigger
--
-- MOD by Defender
--

print("MapMOD: vahaTrigger loaded");

vahaTrigger = {};

local vahaTrigger_mt = Class(vahaTrigger);

_G.vahaOnCreate = function(id)
	table.insert(g_currentMission.updateables, vahaTrigger:new(id));
end;

function vahaTrigger:new(id, customMt)
  print("MapMOD: vahaTrigger:new");
  local instance = {};
  if customMt ~= nil then
    setmetatable(instance, customMt);
  else
    setmetatable(instance, vahaTrigger_mt);
  end;
  instance.CiziId = {};
  instance.pocet = 0;
  instance.vahaid = id;
  instance.vaha = 0;
  addTrigger(id, "vahaTriggerCallback", instance);
  return instance;
end;

function vahaTrigger:delete()
  print("MapMOD: vahaTrigger:delete "..tostring(self.vahaid));
  removeTrigger(self.vahaid);
end;

function vahaTrigger:loadMap(name)
end;

function vahaTrigger:deleteMap()
end;


function vahaTrigger:mouseEvent(posX, posY, isDown, isUp, button)
end;

function vahaTrigger:keyEvent(unicode, sym, modifier, isDown)
end;

function vahaTrigger:update(dt)  
  if self.pocet~=0 then  
    self.vaha = 0;
    for a=1, self.pocet do
      local attachable = g_currentMission.objectToTrailer[self.CiziId[a]];
      local koeficient = 1;
      local fruitname = FruitUtil.fruitIndexToDesc[attachable.currentFillType].name; 
      if (fruitname=="wheat") then
        koeficient = 0.72;
      end;
      if (fruitname=="barley") then
        koeficient = 0.675;
      end;
      if (fruitname=="rape") then
        koeficient = 0.655;
      end;
      if (fruitname=="maize") then
        koeficient = 0.765;
      end;
      if (fruitname=="grass") then
        koeficient = 0.340;
      end;
      if (fruitname=="dryGrass") then
        koeficient = 0.055;
      end;
      if (fruitname=="silage") then
        koeficient = 0.65;
      end;
      if (fruitname=="cotton") then
        koeficient = 1.25;
      end;
      if (fruitname=="manure") then
        koeficient = 0.69;
      end;
      if (fruitname=="potato") then
        koeficient = 0.76;
      end;
      if (fruitname=="sugarbeet") then
        koeficient = 0.66;
      end;
      if (fruitname=="sunflower") then
        koeficient = 0.405;
      end;
      if (fruitname=="fertilizer") then
        koeficient = 2.0;
      end;
      if (fruitname=="dung") then
        koeficient = 0.85;
      end;
      if (fruitname=="rye") then
        koeficient = 0.695;
      end;
      if (fruitname=="oat") then
        koeficient = 0.475;
      end;
      if (fruitname=="soybean") then
        koeficient = 0.7;
      end;
      if (fruitname=="rice") then
        koeficient = 0.84;
      end;
      if (fruitname=="karotte") then
        koeficient = 0.73;
      end;
      if (fruitname=="carrot") then
        koeficient = 0.73;
      end;
      if (fruitname=="mohn") then
        koeficient = 0.59;
      end;
      if (fruitname=="blumkohl") then
        koeficient = 0.66;   --?
      end;
      if (fruitname=="gelbbo") then
        koeficient = 0.5;    --? 
      end;
      if (fruitname=="gruenbo") then
        koeficient = 0.5;   --?
      end;    
      if (fruitname=="sugarcane") then
        koeficient = 1.4;   --?
      end;    
    
      self.vaha = self.vaha + Utils.getNoNil((attachable.fillLevel*koeficient),0);
    end;
    setTextAlignment(RenderText.ALIGN_CENTER);
    renderText(0.5, 0.49, 0.045, string.format("Vaha nakladu %." .. (2 or 0) .. "f", self.vaha).." kg");
    g_currentMission:addWarning("", 0.018, 0.033);
    setTextAlignment(RenderText.ALIGN_LEFT);  
  end; 	
end;

function vahaTrigger:draw()
end;

function vahaTrigger:vahaTriggerCallback(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
  if onEnter then
    if otherId ~= nil then
      local nalezeno=false;
      for a=1, self.pocet do
        if self.CiziId[a]==otherId then
          nalezeno=true;
          break;
        end;
      end;
      if not nalezeno then
        self.pocet=self.pocet+1;
        table.insert(self.CiziId,self.pocet,otherId);
      end;
		end;		
	elseif onLeave then
	  for a=1, self.pocet do
      if self.CiziId[a]==otherId then
        table.remove(self.CiziId,otherId);
        self.pocet=self.pocet-1;
        break;
      end;
    end;      
	elseif onStay then
		if otherId ~= nil then
		end;
	end;	
end;

